--
-- @modified ich 
-- @date  19/05/09

Venta = {};

function Venta.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(SowingMachine, specializations);
end;

function Venta:load(xmlFile)
    self.mainRollerNode  = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.roller#Main"));
    self.rearRollerNode  = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.roller#Rear"));
	self.rollerRotationScale = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.roller#rotScale"), 1);
    
	local workSound = getXMLString(xmlFile, "vehicle.workSound#file");
    if workSound ~= nil and workSound ~= "" then
        workSound = Utils.getFilename(workSound, self.baseDirectory); 
        self.workSound = createSample("workSound");
        self.workSoundEnabled = false;
        loadSample(self.workSound, workSound, false);
        self.workSoundPitchOffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.workSound#pitchOffset"), 1);
        self.workSoundVolume = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.workSound#volume"), 1);
    end;
	self.drumNode1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.drum#index"));
	self.drumNode2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.drum#index2"));
	self.drumNode3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.drum#index3"));
	self.drumNode5 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.drum#index4"));
	self.drumNode6 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.drum#index5"));
	self.drumNode7 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.drum#index6"));
	self.drumNode8 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.drum#index7"));
	self.drumNode9 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.drum#index8"));
	self.drumNode10 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.drum#index9"));
	self.drumNode11 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.drum#index10"));
	self.drumNode12 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.drum#index11"));
	self.drumNode13 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.drum#index12"));
	self.drumRotationScale = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.drum#rotationScale"), 1);
	
	local rotationPartNodeBack = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartBack#index"));
    if rotationPartNodeBack ~= nil then
        self.rotationPartBack = {};
        self.rotationPartBack.node = rotationPartNodeBack;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartBack#minRot"));
        self.rotationPartBack.minRot = {};
        self.rotationPartBack.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartBack.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartBack.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartBack#maxRot"));
        self.rotationPartBack.maxRot = {};
        self.rotationPartBack.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartBack.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartBack.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartBack.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartBack#rotTime"), 2)*1000;
        self.rotationPartBack.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartBack#touchRotLimit"), 10));
    end;
    
	self.rotationMaxBack = true;
    self.lastSoundSpeed = 0;
    self.hasGroundContact = false;
    self.rotationSpeed = 0;

end;

function Venta:delete()

    if self.workSound ~= nil then
        delete(self.workSound);
    end;


end;

function Venta:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Venta:keyEvent(unicode, sym, modifier, isDown)
          
		   if isDown and sym==Input.KEY_b then
               self.turnOn = not self.turnOn;
			   self.rotationMaxBack = not self.rotationMaxBack;
		   end;
end;

function Venta:update(dt)


     

		if self.turnOn and self:getIsActive() then
			
			
			if self.drumNode1 ~= nil then
				rotate(self.drumNode1, self.drumRotationScale * 35 * -3, 0, 0);
			end;
			if self.drumNode2 ~= nil then
				rotate(self.drumNode2, self.drumRotationScale * 35 * -3, 0, 0);
			end;
			if self.drumNode3 ~= nil then
				rotate(self.drumNode3, self.drumRotationScale * 35 * -3, 0, 0);
			end;
			if self.drumNode4 ~= nil then
				rotate(self.drumNode4, self.drumRotationScale * 35 * -3, 0, 0);
			end;
		    if self.drumNode5 ~= nil then
				rotate(self.drumNode5, self.drumRotationScale * 35 * -3, 0, 0);
			end;
			if self.drumNode6 ~= nil then
				rotate(self.drumNode6, self.drumRotationScale * 35 * -3, 0, 0);
			end;
			if self.drumNode7 ~= nil then
				rotate(self.drumNode7, self.drumRotationScale * 35 * -3, 0, 0);
			end;
			if self.drumNode8 ~= nil then
				rotate(self.drumNode8, self.drumRotationScale * 35 * -3, 0, 0);
			end;
			if self.drumNode9 ~= nil then
				rotate(self.drumNode9, self.drumRotationScale * 35 * -3, 0, 0);
			end;
			if self.drumNode10 ~= nil then
				rotate(self.drumNode10, self.drumRotationScale * 35 * -3, 0, 0);
			end;
			if self.drumNode11 ~= nil then
				rotate(self.drumNode11, self.drumRotationScale * 35 * -3, 0, 0);
			end;
			if self.drumNode12 ~= nil then
				rotate(self.drumNode12, self.drumRotationScale * 35 * -3, 0, 0);
			end;
			if self.drumNode13~= nil then
				rotate(self.drumNode13, self.drumRotationScale * 35 * -3, 0, 0);
			end;
		    if not self.workSoundEnabled and self:getIsActiveForSound() then
               playSample(self.workSound, 0, self.workSoundVolume, 0);
               setSamplePitch(self.workSound, self.workSoundPitchOffset);
               self.workSoundEnabled = true;
            end;
		end;
		
		if not self.turnOn and self.workSoundEnabled then
               stopSample(self.workSound);
               self.workSoundEnabled = false;
            end;	
		
		if self.rotationPartBack ~= nil then
        local x, y, z = getRotation(self.rotationPartBack.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartBack.maxRot, self.rotationPartBack.minRot, 3, self.rotationPartBack.rotTime, dt, not self.rotationMaxBack);
        setRotation(self.rotationPartBack.node, unpack(newRot));
        end;
		
          if self.hasGroundContact == true then

					self.rotationSpeed = self.attacherVehicle.lastSpeed * self.attacherVehicle.movingDirection;
                    rotate(self.mainRollerNode,   self.rollerRotationScale * self.rotationSpeed ,0,0);
					rotate(self.rearRollerNode,   self.rollerRotationScale * self.rotationSpeed ,0,0);
				end;
     
end;

function Venta:draw()


end;

function Venta:onAttach()
end;

function Venta:onDetach()
     self.hasGroundContact = false;
end;

function Venta:onLeave()
    if self.deactivateOnLeave then
        Venta.onDeactivate(self);
    else
        Venta.onDeactivateSounds(self);
    end;
end;

function Venta:onDeactivate()
    
         Venta.onDeactivateSounds(self);
end;
function Venta:onDeactivateSounds()
    if self.workSoundEnabled then
        stopSample(self.workSound);
        self.workSoundEnabled = false;
    end;
end;